# Generated by Django 5.2 on 2025-04-23 16:59

import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="BlogPost",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "title",
                    models.CharField(
                        db_index=True,
                        error_messages={
                            "blank": "Title field cannot be empty.",
                            "invalid": "Please enter a valid title.",
                            "max_length": "Title must be at most 255 characters long.",
                            "null": "Title field cannot be null.",
                        },
                        max_length=255,
                        unique=True,
                    ),
                ),
                (
                    "slug",
                    models.SlugField(
                        blank=True,
                        error_messages={
                            "invalid": "Enter a valid slug consisting of letters, numbers, underscores, or hyphens.",
                            "max_length": "Slug must be at most 60 characters long.",
                        },
                        max_length=60,
                        null=True,
                        unique=True,
                    ),
                ),
                (
                    "content",
                    models.TextField(
                        blank=True,
                        default="Describe your blog post here...",
                        error_messages={"invalid": "Please enter valid content."},
                        null=True,
                    ),
                ),
                (
                    "status",
                    models.CharField(
                        choices=[("draft", "Draft"), ("published", "Published")],
                        default="draft",
                        error_messages={
                            "invalid": "Select a valid status.",
                            "max_length": "Status must be at most 10 characters long.",
                        },
                        max_length=10,
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("updated_at", models.DateTimeField(auto_now=True)),
                (
                    "owner",
                    models.ForeignKey(
                        error_messages={
                            "blank": "Owner field cannot be empty.",
                            "does_not_exist": "The specified user does not exist.",
                            "invalid": "Select a valid user.",
                            "invalid_choice": "The selected owner is not a valid choice.",
                            "null": "Owner field cannot be null.",
                        },
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="blog_posts",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "verbose_name": "blog post",
                "verbose_name_plural": "blog posts",
                "db_table": "blog_post",
                "ordering": ["-id"],
            },
        ),
    ]
